import Tkinter as tk
import Image as im
import ImageTk as imtk


def getIndex(event):
    """
    Calculates the index of the field on which was clicked on.
    Returns a number from 0 to 8 indicating the corresponding field.
    """
    global root

# The size of the playing field.
    imgWidth = root.winfo_children()[0].winfo_width()
    imgHeight = root.winfo_children()[0].winfo_height()

# The location of where the click happened
    x = event.x
    y = event.y

    """#############################################################
    You have to calculate the index for the fields list,
    corresponding to the location the user clicked. The imgWidht and
    imgHeight are the width and heigths of the playing field,
    respectively. The x and y are the coordinates in the playing
    field, where the user clicked (o).

     (0,0)                                      (imgWidth, 0)
        -----------------------------------------
        |                                       |
        |                                       |
        |                                       |
        |                                       |
        |                                       |
        |         o                             |
        |         (x,y)                         |
        |                                       |
        |                                       |
        |                                       |
        |                                       |
        |                                       |
        |                                       |
        |                                       |
        |                                       |
        |                                       |
        -----------------------------------------
     (0,imgHeight)                             (imgWidth, imgHeight)
    #############################################################"""
# Put your Code here. If not needed, delete the return below.
    return 0
    """#############################################################
    #############################################################"""


def analyzeFields(fields):
    """
    Checks the fields, if anybody has won or all fields are filled.
    Returns:    1  ... if player one has won
                2  ... if player two has won
                99 ... if no one wins
                0  ... if the game continues
    """

    """#############################################################
    Implement the above described function. The input is fields. This
    is a list of all fields, e.g. [2,1,0,0,1,0,2,1,0]. In the list,
    the first element is the top left field, the second element the top
    middle field, and so on, until the last element, which is the bottom
    right field. A 1 in the list means, that player one has his sign on
    this field, a 2 that player two is occupying this place and a 0 that
    noboady put his mark there yet.

    In the case above, you should return 1, because player one has
    won with the middle column.
    #############################################################"""
# Put your Code here. If not needed, delete the return below.
    return 0
    """#############################################################
    #############################################################"""


def initUi():
    """
    Initializes the user interface.
    """
    global root, fields, player

    fields = 9 * [0]
    player = 1

    root = tk.Tk()
    root.resizable(width=False, height=False)
    root.title("Tic Tac Toe")

    image = im.open("pics/grid.png")
    img = imtk.PhotoImage(image)

    theight = 50

    root.geometry(str(img.width()) + "x" + str(img.height() + theight)
        + "+300+300")

    canvas = tk.Canvas(root, width=img.width(), height=img.height())
    canvas.create_image(0, 0, anchor=tk.NW, image=img)
    canvas.images = []
    canvas.images.append(img)
    root.bindID = canvas.bind("<Button-1>", clickCallback)
    canvas.pack(fill=tk.BOTH, expand=True)

    textF = tk.Label(root, text="Player " + str(player), fg='black')
    textF.pack(padx=0, pady=10, side=tk.LEFT)
    textF.config(font="32")
    root.plText = textF

    textI = tk.Label(root, text="", fg='black')
    textI.pack(padx=0, pady=10, side=tk.RIGHT)
    textI.config(font="32")
    root.InfoText = textI

    return root


def clickCallback(event):
    """
    Handles the event of a click inside the playing field.
    """
    #lint:disable
    global root, fields, player

    ind = getIndex(event)

    if fields[ind] != 0:
        setInfoText("occupied", root)
        return

    setInfoText("good", root)

    fields[ind] = player
    setPic(player, ind, root)

    action = analyzeFields(fields)

    if action == 1:
        setInfoText("winone", root)
    elif action == 2:
        setInfoText("wintwo", root)
    elif action == 99:
        setInfoText("draw", root)

    if action > 0:
        unbind(root)
        return

    player = 1 if player == 2 else 2
    setPlayerString(player, root)
    #lint:enable


def unbind(root):
    """
    Removes the possibility to interact with the playing field,
    when the game is over.
    """
    canvas = root.winfo_children()[0]
    canvas.unbind("<Button-1>", root.bindID)


def setPic(player, ind, root):
    """
    Sets the crosses and circles of the players.
    """
    canvas = root.winfo_children()[0]
    imgWidth = canvas.winfo_width()
    imgHeight = canvas.winfo_height()

    x = ind % 3
    y = ind / 3

    xWidth = float(imgWidth) / 3
    yWidth = float(imgHeight) / 3
    xCoord = x * xWidth
    yCoord = y * yWidth

    if player == 1:
        imgString = "pics/cross.png"
    else:
        imgString = "pics/circle.png"

    image = im.open(imgString)
    image = image.resize((int(xWidth - 40), int(yWidth - 40)), im.ANTIALIAS)
    img = imtk.PhotoImage(image)

    canvas.create_image(xCoord + 20, yCoord + 20, anchor=tk.NW, image=img)
    canvas.images.append(img)
    canvas.pack()


def setPlayerString(player, root):
    """
    Changes the name of the player displayed in the lower left corner.
    """
    root.plText.config(text="Player " + str(player))
    root.plText.config(font="32")


def setInfoText(flag, root):
    """
    Sets the information about the game on the lower right corner.
    """
    messages = {"occupied": "Choose an different field!", "good": "",
            "winone": "Player one wins!!", "wintwo": "Player two wins!!",
            "draw": "No one wins."}
    root.InfoText.config(text=messages[flag])
    root.InfoText.config(font="32")

"""
Where the execution of the file starts.
"""
root = initUi()
root.mainloop()
